#ifndef _MAVATAR_H_
#define _MAVATAR_H_

// trieda premennych a funkcii (objektov) pre pracu s Avatarom
class mAvatar {
public:
 mAvatar();          // konstruktor
 virtual ~mAvatar(); // destruktor

 GLfloat scr_w,scr_h; // sirka, vyska okna

 GLfloat AVATAR_eye;   // vyska oci AVATARa - potrebna pre vypocet kolizii
 GLfloat AVATAR_width; // sirka AVATARa - potrebna pre vypocet kolizii

 GLfloat matrix[16];     // matica kamery
 GLfloat posx,posy,posz; // poloha

 // indikatory pre vykonavanie definovanych posunov kamery
 GLfloat goForward,goBack,goUp,goDown,goRight,goLeft;
 GLfloat goJump,goFast;

 GLubyte isFire1; // strelba1 (lave tlacidlo mysi)
 GLubyte isFire2; // strelba2 (prave tlacidlo mysi)

 GLubyte movetype; // typ pohybu

 GLfloat cam_fps; // pocitadlo FPS (snimky za sekundu)

 // reset parametrov kamery
 void cam_reset(void);
 // reset casu
 void cam_resettime(void);
 // reinicializacia kamery
 void cam_reinit(GLfloat W,GLfloat H);
 // nastavenie perspektivneho premietania
 void cam_set_perspective(void);
 // rotacia kamery
 void cam_rotate_xy(GLfloat X,GLfloat Y);
 void cam_rotate_zl(GLfloat Z);
 void cam_rotate_zr(GLfloat Z);
 // posun kamery
 void cam_move(void);
 // aktualizacia nastaveni kamery
 void cam_update(void);
 // cas medzi vykreslenim 2 snimkov
 GLfloat cam_gettime(void);
private:
 GLuint t_a,t_b; // pomocne premenne

 GLfloat oldx,oldy,oldz;                // povodna poloha
 GLfloat targetx,targety,targetz;       // smer
 GLfloat movx,movy,movz;                // posun kamery
 GLfloat angx,angy,angz,rotx,roty,rotz; // natocenie, rotacia
 GLfloat speed,slide,altit;             // rychlost, bocny pohyb, zmena vysky
 GLfloat acceleration,gravity;          // zrychlenie, gravitacne zrychlenie
 GLfloat viewnear,viewfar;              // minimalny a maximalny dohlad
 GLfloat FOV;                           // zorny uhol pohladu
 GLfloat JumpPower;                     // sila skoku

 // ulozenie stareho a noveho casoveho okamihu (ms)
 GLuint actTime,oldTime;
 // cas vykreslenia sceny
 GLfloat difTime;
 // cas posobenia gravitacie
 GLfloat gravityTime;
};

#endif
