#ifndef _MINTERFACE_H_
#define _MINTERFACE_H_

// triedy pre pracu s jednotlivymi modulmi Enginu
#include "mAvatar.h"
#include "mTexture.h"
#include "mFrontend.h"

typedef struct _material { // struktura OpenGL materialu
 GLfloat amb[4],dif[4],spe[4],amb_dif[4],emi[4];
 GLfloat shi,transp,sillum[4];
};

typedef struct _light { // struktura OpenGL svetla
 GLfloat amb[4],dif[4],spe[4];
 GLfloat pos[4],spot[3];
};

// trieda premennych a funkcii (objektov) pre pracu s OpenGL
class mInterface {
public:
 mInterface();          // konstruktor
 virtual ~mInterface(); // destruktor

 GLint ViewPort[4]; // rozmery okna

 mAvatar Avatar[2]; // 2 Avatari

 // zmena stavov OpenGL stavoveho stroja -----------------------------------
 GLubyte lighting_onoff;  // zap/vyp osvetlenia
 GLubyte help_onoff;      // zap/vyp vypisu helpu
 GLubyte pause_motion;    // zap/vyp casovo zavisleho pohybu objektov
 GLubyte normals_onoff;   // zap/vyp vykreslovania normal
 GLubyte polygon_mode;    // vyplnene trojuholniky/iba hrany

 int ogl_Initialize(void); // inicializacia OpenGL
 int ogl_Draw(void);       // vykreslenie OpenGL sceny
 int ogl_Idle(void);       // casovo zavisla uprava objektov, resp. sceny

 void change_polygon_mode(void);   // vyplnene trojuholniky/iba hrany
 void change_light_pos(GLubyte P); // zmena polohy svetelneho zdroja
private:
 GLuint Aid; // identifikator pouziteho Avatara

 _material ogl_Material[2]; // pouzite materialy

 _light ogl_Light[2];       // pouzite svetla

 GLuint t_a,t_b,t_c; // pomocne premenne

 GLint ogl_State[2]; // pre zistovanie stavov OpenGL stavoveho stroja

 mTexture ogl_Texture;   // instancia triedy mTexture - praca s texturou
 mTriangle ogl_Triangle; // instancia triedy mTriangle - praca s trojuholnikmi
};

#endif
